#include <memory>
#include <quark.hpp>

class ExampleLayer :
	public qk::Layer
{
public:
	ExampleLayer() :
		Layer("Example")
	{ }

	void OnUpdate() override {
		QK_TRACE("ExampleLayer::Update");
	}

	void OnEvent(qk::Event& event) override {
		QK_TRACE(event);
	}
};

class Sandbox :
	public qk::Application
{
public:
	Sandbox() {
		PushLayer(new ExampleLayer);
	}
};

std::unique_ptr<qk::Application> qk::CreateApplication() {
	return std::make_unique<Sandbox>();
}
